<?php

//	All functions return TRUE or FALSE
//	except for the function good_text_cleaned which returns TRUE and
//      the original text with dangerous characters stripped out.
//	list ($ok,$cleanedComments) = good_text_cleaned($_POST["yourComments"]);
//		if ($ok) $yourComments = $cleanedComments;

function good_digits($input) {
	$valid_chars = "0123456789";
	$countGoodChars = 0;
	// if the character (0 to n) in your argument is good, count it
	for ($i=0;$i <= strlen($input)-1; $i += 1) {
		$countGoodChars += strspn($input[$i],$valid_chars);
		}
	// if the # of good chars is not equal to the total # of chars, u got hacking going on.
	if ($countGoodChars != strlen($input)) {
		return FALSE;
		}
	else {
		return TRUE;
		}
}

function good_integers($input) {
	$valid_chars = "0123456789-";	// includes hyphen for negative numbers
	$countGoodChars = 0;
	// if the character (0 to n) in your argument is good, count it
	for ($i=0;$i <= strlen($input)-1; $i += 1) {
		$countGoodChars += strspn($input[$i],$valid_chars);
		}
	// if the # of good chars is not equal to the total # of chars, u got hacking going on.
	if ($countGoodChars != strlen($input)) {
		return FALSE;
		}
	else {
		return TRUE;
		}
}

function good_numbers($input) {
	$valid_chars = "0123456789-.,";	// include period and comma for legibility
	$countGoodChars = 0;
	// if the character (0 to n) in your argument is good, count it
	for ($i=0;$i <= strlen($input)-1; $i += 1) {
		$countGoodChars += strspn($input[$i],$valid_chars);
		}
	// if the # of good chars is not equal to the total # of chars, u got hacking going on.
	if ($countGoodChars != strlen($input)) {
		return FALSE;
		}
	else {
		return TRUE;
		}
}

function good_text($input) {
	// tight edits caused many issues with people never reading the error message
	$valid_chars  = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
	$valid_chars .= "._-@+";	//for email validity
	$valid_chars .= " ,";		//formatting tel# readability no parenthesis
	$valid_chars .= "?";		//relaxed edit on 9/12/2010, people want the question mark to ask questions.
	$valid_chars .= chr(13);	//return
	$valid_chars .= chr(10);	//new line
	//$valid_chars .= chr(09);	//tab really causes problems w/ new host
	$countGoodChars = 0;
	// if the character (0 to n) in your argument is good, count it
	for ($i=0;$i <= strlen($input)-1; $i += 1) {
		$countGoodChars += strspn($input[$i],$valid_chars);
		}
	// if the # of good chars is not equal to the total # of chars, u got hacking going on.
	if ($countGoodChars != strlen($input)) {
		return FALSE;
		}
	else {
		return TRUE;
		}
}

function good_text_cleaned($input) {
	// do not fight it, just strip out the bad characters and let it rip
	$return_message = preg_replace('/[^a-zA-Z0-9 _.\@+\-,\?\\n]/','',$input);
	return array (TRUE,$return_message);
}

function good_name($input) {
	$quote =  "'";			//single quote the calling code must handle stripslashes
	$space = " ";			//single space
	$period = ".";			//some people add the period after a middle initial
	$hyphen = "-";			//hyphenated names
	$valid_chars  = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
	$valid_chars .= $space . $quote . $period . $hyphen;
	$countGoodChars = 0;
	// if the character (0 to n) in your argument is good, count it
	for ($i=0;$i <= strlen($input)-1; $i += 1) {
		$countGoodChars += strspn($input[$i],$valid_chars);
		}
	// if the # of good chars is not equal to the total # of chars, u got hacking going on.
	if (substr_count($input,$quote) > 1) { // only allow one quote or appostrophy
		return FALSE;
		}
	if ($countGoodChars != strlen($input)) {
		return FALSE;
		}
	// if the if conditions above do not return bad news, assume the input is OK
	return TRUE;
}

function good_telno($input) {
	$lparend = "(";		//if you have a parend, you must have exactly
	$rparend = ")";		//one of each
	$hyphen  = "-";
	$space   = " ";
	$valid_chars  = "0123456789";
	$valid_chars .= $lparend . $space . $rparend . $hyphen;
	$countGoodChars = 0;
	// if the character (0 to n) in your argument is good, count it
	for ($i=0;$i <= strlen($input)-1; $i += 1) {
		$countGoodChars += strspn($input[$i],$valid_chars);
		}
	// if the # of good chars is not equal to the total # of chars, u got hacking going on.
	if ($countGoodChars != strlen($input)) {
		return FALSE;
		}
	// parends, if present, must be exactly one each.
	$countl = substr_count($input,$lparend);
	$countr = substr_count($input,$rparend);
	if ($countl != $countr) {	// unbalanced L & R parends
		return FALSE;
		}
	if ($countr > 1) {	// balanced, but not equal to zero or one
		return FALSE;
		}
	// if the if conditions above do not return bad news, assume the input is OK
	return TRUE;
}

function good_email($input) {
	$mytbd = 0;		// webmaster type override, accept string "t.b.d." ot "tbd"
	$valid_chars  = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
	$valid_chars .= "._-@+";	//for email validity
	$countGoodChars = 0;
	// if the character (0 to n) in your argument is good, count it
	for ($i=0;$i <= strlen($input)-1; $i += 1) {
		$countGoodChars += strspn($input[$i],$valid_chars);
		}
	// if the # of good chars is not equal to the total # of chars, u got hacking going on.
	if ($countGoodChars != strlen($input)) {
		return FALSE;
		}
	// allow tbd or t.b.d. as email address names
	$lowerinput =  strtolower($input);
	if (($lowerinput == 'tbd') OR ($lowerinput == 't.b.d.')) {
		$mytbd = 1;	// found a tbd entry, so email is considered good.
		return TRUE;
		}
	// further edits if input is not empty and not tbd
	// you must have exactly one at (@) sign
	if ( ($mytbd == 0) AND (substr_count($input, '@') != 1) ) {
		return FALSE;
		}
	// the destination domain name must be valid
	// no way can we check every possible email addr within the domain
	if ( ($mytbd == 0) AND ($input != "") AND (strrpos($input,"@") < $countGoodChars) ) {
		$domainaddr  = explode("@", $input);
		if (isset($domainaddr[1])) {
			$domain = $domainaddr[1];
			$mxhosts_array = array();	// optional, make sure it is an array
			if (!getmxrr($domain, $mxhosts_array)) {
				return FALSE;
				}
			}
		}
	// if the conditions above do not return bad news, assume the input is OK
	return TRUE;
}

function good_datetime($input) {
	// valid character edits only. If you mess up the format then life sucks
	$valid_chars = "0123456789 -:";	// stored in mysql db as "yyyy-mm-dd hh:mm:ss"
	$countGoodChars = 0;
	// if the character (0 to n) in your argument is good, count it
	for ($i=0;$i <= strlen($input)-1; $i += 1) {
		$countGoodChars += strspn($input[$i],$valid_chars);
		}
	// if the # of good chars is not equal to the total # of chars, u got hacking going on.
	if ($countGoodChars != strlen($input)) {
		return FALSE;
		}
	else {
		return TRUE;
		}
}

function good_url_args($input) {
	// specifically written for the sendemail.php which accepts, via the url,
	// an email address, or fname%20lname, or a digit, all in one toemail=
	// it also accepts %20 (spaces) in the subject= argument.
	// url is sendemail.php?toemail=howard%20griffin&subject=Never%20More
	$valid_chars  = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
	$valid_chars .= "._-@+";		// for email characters
	$valid_chars .= "% ";			// % is for %20 only,
	$countGoodChars = 0;
	// if the character (0 to n) in your argument is good, count it
	for ($i=0;$i <= strlen($input)-1; $i += 1) {
		$countGoodChars += strspn($input[$i],$valid_chars);
		}
	// if the # of good chars is not equal to the total # of chars, u got hacking going on.
	if ($countGoodChars != strlen($input)) {
		return FALSE;
		}
	// if the % is followed by anything but 20 (%20 is a space) then reject it
	if ( substr_count($input,'%') != substr_count($input,'%20') ) {
		return FALSE;
		}
	// if you have an ampersand, you only get one.
	if (substr_count($input, '@') > 1) {
		return FALSE;
		}
	// the destination domain name, if it exists, must be valid
	if (substr_count($input, '@') == 1) {
		$domainaddr  = explode("@", $input);
		$domain = $domainaddr[1];
		$mxhosts_array = array();	// optional, make sure it is an array
		if (!getmxrr ($domain, $mxhosts_array)) {
			return FALSE;
			}
		}
	// if the conditions above do not return bad news, assume the input is OK
	return TRUE;
}

?>
