<?php
session_start();
$currUser = "";
if (isset($_SESSION["currUser"])) $currUser = $_SESSION["currUser"];
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta name="author"              content="Howard Griffin">
<meta charset="utf-8">
<meta name="viewport"            content="width=device-width, initial-scale=1.0">
<link rel="stylesheet"           type="text/css"     href="hgg_style.css">
<title>List Volunteer Opportunities</title>
</head>

<body>
<?php
//-----------------------------------------------------------------------------
// version 1   Working at Potomac CC
// version 2   PCC specific code removed, upgraded SQL & php code, misc. enhancements
// version 3.0 April, 2016, additional enhancements, tracking of IP address, MySQL table changes
//-----------------------------------------------------------------------------
include("db_connect.php");
include("set_timezone.php");
$link = connectToMysqli();
include("data_valid_fns.php");
include("masthead.php");

//--------------------------------------------------------------------
// validate and assign arguments
// Edits are in:  data_valid_fns.php which must be included
// url syntax is ....php?start=2016-02-15
//--------------------------------------------------------------------
$start = date("Y-m-d");
if (isset($_GET["start"])) {
	if (good_datetime($_GET["start"])) $start = $_GET["start"];
	else print "Invalid start date specified in URL<br>";
	}
print "<p class=\"pcc3center\">Listing of Volunteer Opportunities ";
print "<br>starting on: $start </p>";

print "<blockquote>";
print "<p>You may choose a different start date by including the start date in the url as follows:<br>";
print " .../listVolunteerEvents.php?start=2019-03-05</p>";
print "<p>If you are not logged in, the non published comments, where available, are suppressed.</p>";
print "</blockquote>";
?>

<blockquote>
<p>Copy the text below, including the header line, to Notepad or your favorite text editor<br>
Save locally as a .csv file, and double click to launch via Excel<br>
Slice and Dice to your heart's content.</p>

<p class="nomargin"><span style="font-weight:bold;">
<?php
//-----------------------------------------------------------------------------
// print headers for copying into .csv file
//-----------------------------------------------------------------------------
print "event,task,start date &amp; time,stop date & time,number volunteers,non-pub comments";
if ($currUser !== "") {
	print ",nonPubComments";
	}
print "</span><br>";

$query1  = "select * from vol_task where startTime >= '$start' ";
$result1 = mysqli_query($link,$query1);
if (!$result1) {
	print "oops, something seems to have gone wrong with query1.<br>";
	print $query1;
	print "<br>sql error: " . mysqli_error($link) . "<br>";
	}
while ($i=mysqli_fetch_row($result1)) {
	$taskID			= $i[0];
	$event_desc		= $i[1];
	$task_desc		= $i[2];
	$startTime		= substr($i[3],0,16);
	$stopTime		= substr($i[4],0,16);
	$numVolunteers	= $i[5];
	$nonPubComments	= $i[6];
	$nonPubComments	= str_replace(",","",$nonPubComments);  // strip out commas so the .csv format works
	if ( ($currUser == "") AND ($nonPubComments !== "") ) {
		$nonPubComments = "suppressed";
		}
	print "$event_desc,$task_desc,$startTime,$stopTime,$numVolunteers,$nonPubComments<br>";
	}
?>
</p><p>
--- end of report ---
</blockquote>
<p>&nbsp;</p>

</body>
</html>
