use test;

DROP TABLE IF EXISTS `curlers`;
CREATE TABLE `curlers` (
  `curlerID` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `fname` varchar(25) NOT NULL DEFAULT '',
  `lname` varchar(35) NOT NULL DEFAULT '',
  `email` varchar(80) NOT NULL DEFAULT '',
  `member` tinyint(4) NOT NULL DEFAULT '0',
  UNIQUE KEY `curlerID` (`curlerID`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `vol_people`;
CREATE TABLE `vol_people` (
  `volunteerID` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `taskID` smallint(5) unsigned NOT NULL,
  `curlerID` smallint(5) unsigned NOT NULL,
  `date_added` datetime NOT NULL,
  `date_removed` datetime NOT NULL,
  PRIMARY KEY (`volunteerID`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `vol_task`;
CREATE TABLE `vol_task` (
  `taskID` smallint(5) NOT NULL AUTO_INCREMENT,
  `event_desc` varchar(30) NOT NULL,
  `task_desc` varchar(40) NOT NULL,
  `startTime` datetime NOT NULL,
  `stopTime` datetime NOT NULL,
  `numVolunteers` tinyint(3) NOT NULL,
  `nonPubComments` varchar(45) NOT NULL,
  PRIMARY KEY (`taskID`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

INSERT INTO `vol_task` VALUES (1,'Open House','On-ice Instructors','2014-02-08 19:00:00','2014-02-08 21:00:00',8,'');
INSERT INTO `vol_task` VALUES (2,'Open House','Warm Room Greeters','2014-02-08 18:30:00','2014-02-08 21:30:00',8,'');
INSERT INTO `vol_task` VALUES (3,'Open House','Play demo game','2014-02-08 19:00:00','2014-02-08 21:00:00',8,'');
INSERT INTO `vol_task` VALUES (4,'Open House','On-ice Instructors','2014-02-15 19:00:00','2014-02-15 21:00:00',8,'');
INSERT INTO `vol_task` VALUES (5,'Open House','Warm Room Greeters','2014-02-15 18:30:00','2014-02-15 21:30:00',8,'');
INSERT INTO `vol_task` VALUES (6,'Open House','Play demo game','2014-02-15 19:00:00','2014-02-15 21:00:00',8,'');
INSERT INTO `vol_task` VALUES (7,'Learn to Curl','Instructors','2014-02-09 12:00:00','2014-02-09 15:00:00',8,'');
INSERT INTO `vol_task` VALUES (8,'Learn to Curl','Instructors','2014-02-16 12:00:00','2014-02-16 15:00:00',8,'');
INSERT INTO `vol_task` VALUES (09,'Facility Rental','Instructors','2014-01-11 11:30:00','2014-01-11 16:00:00',4,'Boston Properties');
INSERT INTO `vol_task` VALUES (10,'Facility Rental','Instructors','2014-01-18 10:00:00','2014-01-18 15:00:00',8,'Marriott, red-hot-blue catered');
INSERT INTO `vol_task` VALUES (11,'Junior Program','Coaches','2014-01-15 12:00:00','2014-01-15 15:00:00',8,'');
INSERT INTO `vol_task` VALUES (12,'Junior Program','Coaches','2014-01-22 12:00:00','2014-01-22 15:00:00',8,'');

INSERT INTO `curlers` VALUES (1,'Howard','Griffin','sweephard@gmail.com',1);
INSERT INTO `curlers` VALUES (2,'Elmer','Fudd','elmer@wb.com',0);
INSERT INTO `curlers` VALUES (3,'Daffy','Duck','daffy@wb.com',0);
INSERT INTO `curlers` VALUES (4,'Foghorn','Leghorn','elmer@wb.com',0);
INSERT INTO `curlers` VALUES (5,'Bugs','Bunny','bugs@wb.com',0);

INSERT INTO `vol_people` (`volunteerID`, `taskID`, `curlerID`, `date_added`, `date_removed`) VALUES
(1, 9, 5, '2013-06-25 19:13:04', '0000-00-00 00:00:00'),
(2, 9, 3, '2013-06-25 19:13:15', '0000-00-00 00:00:00'),
(3, 9, 2, '2013-06-25 19:13:22', '0000-00-00 00:00:00'),
(4, 9, 4, '2013-06-25 19:13:31', '0000-00-00 00:00:00'),
(5, 10, 1, '2013-06-25 19:13:53', '0000-00-00 00:00:00');

